

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "webwisdom_tango_main_LocalBase.h"

/* PLUGIN */

#include "npapi.h"

/* END PLUGIN */

#define MAXPATHLEN 100 

/* Tango variables */
char *server="";
char *port="";
char *localp="";

/* end of Tango variables */

JRIEnv* env;

/* PLUGIN */
/* **************** Here starts code for plugin in Netscape********** */
char *
NPP_GetMIMEDescription(void)
{
  return("application/x-collaboratory:tin:Tango plug-in");
}


NPError
NPP_GetValue(void *future, NPPVariable variable, void *value)
{
	NPError err = NPERR_NO_ERROR;

	switch (variable) {
		case NPPVpluginNameString:
			*((char **)value) = "TANGO Interactive Collaboratory";
			break;
		case NPPVpluginDescriptionString:
			*((char **)value) =
				"TANGO Interactive plug-in for IRIX 5.3, v. 1.0";
			break;
		default:
			err = NPERR_GENERIC_ERROR;
	}
	return err;
}

NPError
NPP_Initialize(void)
{
  return NPERR_NO_ERROR;
}

jref
NPP_GetJavaClass()
{
   env = NPN_GetJavaEnv();
   return use_webwisdom_tango_main_LocalBase(env);
}

void
NPP_Shutdown(void)
{
                unuse_webwisdom_tango_main_LocalBase(env);
}

NPError 
NPP_New(NPMIMEType pluginType,
	NPP instance,
	uint16 mode,
	int16 argc,
	char* argn[],
	char* argv[],
	NPSavedData* saved)
{

  	NPError result = NPERR_NO_ERROR; /*new*/
	char buffer[1024]; 

	if (instance == NULL)
		return NPERR_INVALID_INSTANCE_ERROR;
       	

	if (argc>2) {
		int i;

		for (i=0;i<argc;i++) {
		
		   if(argn[i]==NULL) {
            		fprintf(stderr, "TANGO plugin warning: null-name parameter passed(%d)\n", i); 
			
     		} else {							
										
				sprintf(buffer,"Param %s = %s",argn[i],argv[i]);
				if (strcasecmp(argn[i],"SERVER")==0) {
					server=NPN_MemAlloc( strlen( argv[i] ) + 1 );
					strcpy(server,argv[i]);
					}
				if (strcasecmp(argn[i],"PORT")==0) {
					port=NPN_MemAlloc( strlen( argv[i] ) + 1 );
					strcpy(port,argv[i]);

				}
				if (strcasecmp(argn[i],"LOCALPORT")==0) {
					localp=NPN_MemAlloc( strlen( argv[i] ) + 1 );
					strcpy(localp,argv[i]);
				}
				
			}
		}
	}
	
	fprintf(stderr, "TANGO plugin: server %s port %s localport %s \n", server, port, localp); 
 
	return result;

      
}/* NPP_New */


NPError 
NPP_Destroy(NPP instance, NPSavedData** save)
{

  
	if (instance == NULL)
		return NPERR_INVALID_INSTANCE_ERROR;

	/* PLUGIN DEVELOPERS:
	 *	If desired, call NP_MemAlloc to create a
	 *	NPSavedDate structure containing any state information
	 *	that you want restored if this plugin instance is later
	 *	recreated.
	 */
 
	
	 if (strcmp(localp,"")!=0) {
		  NPN_MemFree(localp);	 
	 }		
	  
	 if (strcmp(port,"")!=0) {
		  NPN_MemFree(port);	 
	 }
	 
	  if (strcmp(server,"")!=0) {
		  NPN_MemFree(server);	 
	 }  
				
	return NPERR_NO_ERROR;
}/* NPP_Destroy */



NPError 
NPP_SetWindow(NPP instance, NPWindow* window)
{
	if (instance == NULL)
		return NPERR_INVALID_INSTANCE_ERROR;

	/*
	 * PLUGIN DEVELOPERS:
	 *	Before setting window to point to the
	 *	new window, you may wish to compare the new window
	 *	info to the previous window (if any) to note window
	 *	size changes, etc.
	 */
	

	return NPERR_NO_ERROR;
}/* NPP_SetWindow */


NPError 
NPP_NewStream(NPP instance,
	      NPMIMEType type,
	      NPStream *stream, 
	      NPBool seekable,
	      uint16 *stype)
{

 
	if (instance == NULL)
		return NPERR_INVALID_INSTANCE_ERROR;

/*--- Start custom code */
	/* Initial Netscape window size set to QCIF */


	/* initialize variables */
	    
/*--- End custom code */
	
	return NPERR_NO_ERROR;
}/* NPP_NewStream */


/* PLUGIN DEVELOPERS:
 *	These next 2 functions are directly relevant in a plug-in which
 *	handles the data in a streaming manner. If you want zero bytes
 *	because no buffer space is YET available, return 0. As long as
 *	the stream has not been written to the plugin, Navigator will
 *	continue trying to send bytes.  If the plugin doesn't want them,
 *	just return some large number from NPP_WriteReady(), and
 *	ignore them in NPP_Write().  For a NP_ASFILE stream, they are
 *	still called but can safely be ignored using this strategy.
 */

int32 
NPP_WriteReady(NPP instance, NPStream *stream)
{
    return 0;

}


int32 
NPP_Write(NPP instance, NPStream *stream, int32 offset, int32 len, void *buffer)
{	
        return len;		/* The number of bytes accepted */
}
 

NPError 
NPP_DestroyStream(NPP instance, NPStream *stream, NPError reason)
{
  
	if (instance == NULL)
		return NPERR_INVALID_INSTANCE_ERROR;

	return NPERR_NO_ERROR;
}

void 
NPP_StreamAsFile(NPP instance, NPStream *stream, const char* fname)
{
    return;
}
 
void 
NPP_Print(NPP instance, NPPrint* printInfo)
{
    return;
}

void 
NPP_URLNotify(NPP instance, const char *url, NPReason reason, void* notifyData)
{
    return;
}


/* **************** Here ends code for plugin in Netscape********** */


JRI_PUBLIC_API(void)
native_webwisdom_tango_main_LocalBase_runApplication(JRIEnv* env, webwisdom_tango_main_LocalBase* self, struct java_lang_String *a, int AID, int SID, int AT, int port) {

   char AIDstring[20], PORTstring[20], SIDstring[20], ATstring[20]; 
   
  
  int childpid; 
  char *root;
  const char *buf = JRI_GetStringUTFChars(env, a);
  char path[MAXPATHLEN];
  char filename[MAXPATHLEN];
  char *slash_pos;
  int i;
  int status;
 
  root = getenv("TANGO_APP_ROOT"); 

  if (root == NULL || a == NULL) { 
     fprintf(stderr, "TANGO plugin: cannot find variable TANGO_APP_ROOT \n"); 
     return;
  }
        
   sprintf(path, "%s%s", root, buf);
   sprintf(AIDstring, "%d", AID); 
   sprintf(SIDstring, "%d", SID); 
   sprintf(ATstring, "%d", AT); 
   sprintf(PORTstring, "%d", port); 
   
   slash_pos = strrchr(buf, '/');
   
   if(slash_pos == NULL) {
   
        fprintf(stderr, "TANGO plugin: wrong format of application start string: %s ", buf);     
        return;
   }
   
   sprintf(filename, "%s" , (slash_pos + 1));   

   childpid = fork(); 

   if (childpid == -1) {
      fprintf(stderr, "TANGO plugin: cannot fork"); 
      return;
    }

   if (childpid == 0) { 
   /*   fprintf(stderr, "running %s %s %s", rpath, AIDstring, PORTstring);   */
     for(i = 3; i < 256; i ++)  
       close(i); 

    fprintf(stderr, "running %s %s %s %s", path, filename, AIDstring, SIDstring, ATstring, PORTstring);      
    status = execl(path, filename, AIDstring, SIDstring, ATstring, PORTstring, (char *) 0);   
 
    fprintf(stderr, "TANGO plugin: cannot run %s ", buf);
    exit(0);
   }   
}

JRI_PUBLIC_API(struct java_lang_String *)   
native_webwisdom_tango_main_LocalBase_getServerHost(JRIEnv* env, struct webwisdom_tango_main_LocalBase* self) {
  
    char hostname[100];
    struct java_lang_String *result;   
     
    if (strcmp(server,"")!=0) {
  /*		MessageBox( NULL, "Copying value", "SERVER_VALUE", MB_ICONEXCLAMATION ); */
		  strcpy(hostname,server);
		  
    } else {
        
	fprintf(stderr, "TANGO plugin: error in server host format\n"); 
	hostname[0] = '*';
	hostname[1] = '\0';

      
    }
    result = (struct java_lang_String *) JRI_NewStringUTF(env, hostname, (jsize) strlen(hostname)); 
    
    return result;
  }


JRI_PUBLIC_API(jint)  
native_webwisdom_tango_main_LocalBase_getServerPort(JRIEnv* env, webwisdom_tango_main_LocalBase* self) {

    char serverport[10];  

    if (strcmp(port,"")!=0) {
		  strcpy(serverport,port);
    } else {

  
    	fprintf(stderr, "TANGO plugin: error in server port format\n"); 
	return 0;
    }  

    return atoi(serverport);

  }

JRI_PUBLIC_API(jint)   
native_webwisdom_tango_main_LocalBase_getLocalPort(JRIEnv* env, webwisdom_tango_main_LocalBase* self) {

    char localport[10];

    if (strcmp(localp,"")!=0) {
		  strcpy(localport,localp);
    } else {
   
      fprintf(stderr,"TANGO plugin: error in local port format\n");
      return 0;
    }

    return atoi(localport); 
}


  
  
 











